(function ($) {
  /** Extend ajax commands for update cart block **/
  Drupal.ajax.prototype.commands.commerce_ajax_cart_update = function (ajax, response, status ) {
    $.post(Drupal.settings.basePath + 'cart/ajax/update',function(data) {
      jQuery('.view-id-shopping_cart').replaceWith(data) ;
      /** Reattach behaviour **/
      Drupal.behaviors.commerce_add_to_cart_show_ajax_cart.attach(jQuery('.view-id-shopping_cart').parent());
      Drupal.behaviors.commerce_add_to_cart_show_ajax_cart.fillCartBlock() ;
      if ( jQuery('.commerce-add-to-cart-confirmation').length > 0 ) {
        var options = { "my" : "center center" , "at" : "center center" , "of" : jQuery(window) };
        jQuery('.commerce-add-to-cart-confirmation').position(options) ;
      }
    }) ;
  }
  Drupal.behaviors.commerce_add_to_cart_show_ajax_cart = {
   fillCartBlock : function() {
     jQuery('a.commerce-ajax-cart-loader').each(function(){
       $.post(Drupal.settings.basePath + 'cart/ajax/block',function(data) {
         jQuery('a.commerce-ajax-cart-loader').html(data);
       }) ;
     })
   },
   repositioning : function() {
     var options = {
         "my"        : Drupal.settings.commerce_ajax_cart.position.my,
         "at"        : Drupal.settings.commerce_ajax_cart.position.at,
         "of"        : $('.view-id-shopping_cart').parent(),
         "collision" : Drupal.settings.commerce_ajax_cart.position.collision
       };
     jQuery('#commerce-ajax-cart-preview').position(options) ;
   },
  	attach:function (context, settings) {
     /** Call for chached sites to update block display **/
  	  var container = jQuery(context).find('.view-id-shopping_cart').parent(); 
     jQuery(container).once('commerce-ajax-cart-processed', function() {
       Drupal.ajax.prototype.commands.commerce_ajax_cart_update();
       Drupal.behaviors.commerce_add_to_cart_show_ajax_cart.fillCartBlock(context) ;
     });
     jQuery('#dc-cart-ajax-form-wrapper form').once('commerce-ajax-cart-update',function(){
       jQuery(this).find('a').bind('click',function(){
         Drupal.ajax.prototype.commands.commerce_ajax_cart_update();
       })
     })
     
   		container.bind('mouseenter', function(e) {
       e.preventDefault();  

       /** Check if preview div is alread created **/
       if ( jQuery('#commerce-ajax-cart-preview').length > 0 ) return ;
       
       /** Append div container **/
       jQuery(this).append('<div class="loading" id="commerce-ajax-cart-preview"><span>Loading</</div>');
       
       /** Bind mousehandler for close cart preview **/
       jQuery('#commerce-ajax-cart-preview').bind('mouseleave',function(){
     	   jQuery('#commerce-ajax-cart-preview').remove();
       })

       /** Set position for cart preview with jquery.ui.position **/
       //jQuery('#commerce-ajax-cart-preview').position(options) ;
       Drupal.behaviors.commerce_add_to_cart_show_ajax_cart.repositioning() ;
       
       /** Update cart preview **/
       $.post(Drupal.settings.basePath + 'cart/ajax',function(data) {
         jQuery('#commerce-ajax-cart-preview').removeClass('loading').html(data);
         Drupal.behaviors.commerce_add_to_cart_show_ajax_cart.repositioning() ;
       }) ;
       
     }).bind('mouseleave',function(){
       /** Bind mousehandler for close cart preview **/
     	jQuery('#commerce-ajax-cart-preview').remove();
     });
   }
  }
})(jQuery);

